<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';


require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

require_once $base_path_to_learning . 'principal_api/modules/dashboard/dashboard_functions.php';
// require_once $base_path_to_learning_resources . 'lib/student_birthdays/function.php';
require_once $base_path_to_learning_resources . 'lib/common_modules/item/functions.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);
checkIfNoPhpContentsReceive();

if (
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or
    !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;


$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["principal"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific, $version, $updated_time, $userid, $institution_id);

if ($postdata['function_type'] == "fetch_admin_dashboard") {

    if (isset($postdata['from_date']) and !empty($postdata['from_date'])) {
        $from_date = trim($postdata['from_date']);
    } else {
        // $from_date = null;
        $from_date = date('Y-m-d');
    }
    // if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
    //     $to_date = trim($postdata['to_date']);
    // } else {
    //     $to_date = null;date('Y-m-d')
    // }
    if (isset($postdata['to_date']) and !empty($postdata['to_date'])) {
        $to_date = trim($postdata['to_date']);
    } else {
        $to_date = date('Y-m-d');
    }

    if ($from_date > $to_date) {
        errorreturn('Invalid Date format');
    }


    $getActive_and_inactivestudents = getActiveAndInactiveStudentCounts($conn_rjllearning_specific, $institution_id, $branch_id);

    $registered_students_faculty = getRegistered_studentCounts($from_date, $to_date, $institution_id, $branch_id, $conn_rjllearning_specific);

    $fuel_consumption = getTotalFuelConsumption($from_date, $to_date, $institution_id, $branch_id, $conn_rjllearning_specific);

    $expired_docs = fetchExpiredDocumentCounts($institution_id, $branch_id, $conn_rjllearning_specific);

    $attendance_stats = fetchAttendanceStats($conn_rjllearning_specific, $institution_id, $branch_id, $to_date);
    
    $transactions = fetchTransactions($institution_id, $branch_id, $conn_rjllearning_specific, $from_date, $to_date);
    
    $gate_pass_stats = fetchGatePassCounts($conn_rjllearning_specific, $institution_id, $branch_id, $from_date, $to_date); //new added
    
    // $mail_sms_stats = fetchMailSmsStats($institution_id, $branch_id, $conn_rjllearning, $from_date, $to_date);
    
    $mail_sms_stats = fetchMailSmsStats($institution_id, $branch_id, $conn_rjllearning, $to_date);
    
    // $student_faculty_birthdays = get_student_birthday($conn_rjllearning, $institution_id, $branch_id, $from_date, $to_date);
        $student_faculty_birthdays = get_specific_birthday($conn_rjllearning, $conn_rjllearning_specific, $institution_id, $branch_id, $from_date, $to_date,$workspace_id);
        

    
    $inventory_trans_stats = fetch_inventory_transactions_stats($institution_id, $branch_id, $from_date, $to_date, $conn_rjllearning_specific);

    
    $result = [
        'getActive_and_inactive_students_and_faculty' => $getActive_and_inactivestudents,
        'registered_students_count' => $registered_students_faculty,
        'fuel_consumption' => $fuel_consumption,
        'expired_docs' => $expired_docs,
        'attendance_stats' => $attendance_stats,
        'transactions' => $transactions,
        'gate_pass_stats' =>$gate_pass_stats,
        'mail_sms_stats' => $mail_sms_stats,
        'birthday_details' => $student_faculty_birthdays,
        'inventory_trans_stats' => $inventory_trans_stats
    ];

    successreturn($result);
}